//+------------------------------------------------------------------+
//|                                                 ZZ SAMPLE 1 .mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

//EXTERNAL VALUES+++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
extern double Lots = 0.1;
extern double TrailingStop = 100;
extern double takeProfit = 200;

extern int StopLoss = 50;

datetime Time0 = 0;

//---- indicator parameters
extern int ExtDepth=12;
extern int ExtDeviation=5;
extern int ExtBackstep=3;
//---- indicator buffers
double ExtMapBuffer[];
double ExtMapBuffer2[];

double ZZ2=0,ZZ3=0;
extern int depth=12,deviation=5,backstep=3;


//COLLECTED DATA++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


int cnt, ticket, total;
int BarsCount=0;

//EA IDENTIFIER+++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

extern string nameEA       = "ZZ";

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   
  
   if(Bars<100)
   
     {
      Print("bars less than 100");
      return(0);  
     }
     
//CALCULATING INDICATORS++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 

   
double zzUpper1 = iCustom(NULL,0,"ZigZag",12,5,3,0,0); // from 1st buffer
double zzLower2 = iCustom(NULL,0,"ZigZag",12,5,3,1,0); // from 2nd buffer 

double   ZZ3=iCustom(NULL,0,"ZigZag",depth,deviation,backstep,0,1);
double   ZZ2=iCustom(NULL,0,"ZigZag",depth,deviation,backstep,0,0);
 
   
   
    
//TRADING+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  

   total=OrdersTotal();
  
     
      
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
        
        
//ENTERING MARKET++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   
        
//CHECKING FOR LONG POSITION OPENING+++++++++++++++++++++++++++++++++++




if (Time0 != Time[0])
{
      if(zzUpper1<zzLower2)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,2,Bid-StopLoss*Point,Ask + takeProfit*Point,"ZZ",1,0,Green);
         Time0 = Time[0];
         
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("ZZ BUY order opened : ",OrderOpenPrice());
           }
           
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
       
     //EXITING MARKET+++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
     for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      
      if(OrderType()<=OP_SELL &&    
         OrderSymbol()==Symbol())  
        {
        
         //CHECKING FOR LONG POSITION CLOSING+++++++++++++++++++++++++++++++++++
        
         if(OrderType()==OP_BUY)   
           {
            
            if(zzUpper1>zzLower2)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
          
        }
     }
}
       
//CHECKING FOR SHORT POSITION OPENING+++++++++++++++++++++++++++++++++++

if (Time0 != Time[0])
{
      if(zzUpper1>zzLower2)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,2,Ask+StopLoss*Point,Bid - takeProfit*Point,"ZZ",1,0,Red);
         Time0 = Time[0];
         
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("ZZ SELL order opened : ",OrderOpenPrice());
           }
           
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
   
   //EXITING MARKET+++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&    
         OrderSymbol()==Symbol())  
        {          
          
          //CHECKING FOR SHORT POSITION CLOSING+++++++++++++++++++++++++++++++++++           
                      
          if(zzUpper1<zzLower2)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
              
            // check for trailing stop
            
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
         }
      }
    
}      
   
   return(0);
  }
 